Index: squid/src/fs/hash/store_io_hash.c
diff -u /dev/null squid/src/fs/hash/store_io_hash.c:1.1.2.6
--- /dev/null	Sun Jan 25 06:37:04 2004
+++ squid/src/fs/hash/store_io_hash.c	Sun Mar 18 14:51:22 2001
@@ -0,0 +1,283 @@
+
+/*
+ * $Id: squid-modio-HEAD,v 1.1 2004/08/17 20:55:12 hno Exp $
+ *
+ * DEBUG: section 79    Storage Manager HASH Interface
+ * AUTHOR: Duane Wessels
+ *
+ * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
+ * ----------------------------------------------------------
+ *
+ *  Squid is the result of efforts by numerous individuals from the
+ *  Internet community.  Development is led by Duane Wessels of the
+ *  National Laboratory for Applied Network Research and funded by the
+ *  National Science Foundation.  Squid is Copyrighted (C) 1998 by
+ *  Duane Wessels and the University of California San Diego.  Please
+ *  see the COPYRIGHT file for full details.  Squid incorporates
+ *  software developed and/or copyrighted by other sources.  Please see
+ *  the CREDITS file for full details.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
+ *
+ */
+
+#include "squid.h"
+#include "store_hash.h"
+
+
+static DRCB storeHashReadDone;
+static DWCB storeHashWriteDone;
+static void storeHashIOCallback(storeIOState * sio, int errflag);
+static void storeHashIOFreeEntry(void *);
+
+CBDATA_TYPE(storeIOState);
+
+/* === PUBLIC =========================================================== */
+
+void
+storeHashGet(SwapDir *sd, request_t *request, STGETDONE *callback,
+    void *callback_data)
+{
+    /* Empty for now , return NULL */
+    storeLookupComplete(request, callback, callback_data, NULL);
+}
+
+storeIOState *
+storeHashOpen(SwapDir * SD, StoreEntry * e, STFNCB * file_callback,
+    STIOCB * callback, void *callback_data)
+{
+    sfileno f = e->swap_filen;
+#if 0
+    char *path = storeHashDirFullPath(SD, f, NULL);
+#endif
+    char *path;
+    storeIOState *sio;
+    struct stat sb;
+    int fd;
+    debug(79, 3) ("storeHashOpen: fileno %08X\n", f);
+    fd = file_open(path, O_RDONLY);
+    if (fd < 0) {
+	debug(79, 3) ("storeHashOpen: got failure (%d)\n", errno);
+	return NULL;
+    }
+    debug(79, 3) ("storeHashOpen: opened FD %d\n", fd);
+    CBDATA_INIT_TYPE_FREECB(storeIOState, storeHashIOFreeEntry);
+    sio = cbdataAlloc(storeIOState);
+    sio->fsstate = memPoolAlloc(hash_state_pool);
+
+    sio->swap_filen = f;
+    sio->swap_dirn = SD->index;
+    sio->mode = O_RDONLY;
+    sio->callback = callback;
+    sio->callback_data = callback_data;
+    cbdataLock(callback_data);
+    sio->e = e;
+    ((hashstate_t *) (sio->fsstate))->fd = fd;
+    ((hashstate_t *) (sio->fsstate))->flags.writing = 0;
+    ((hashstate_t *) (sio->fsstate))->flags.reading = 0;
+    ((hashstate_t *) (sio->fsstate))->flags.close_request = 0;
+    if (fstat(fd, &sb) == 0)
+	sio->st_size = sb.st_size;
+    store_open_disk_fd++;
+
+    /* We should update the heap/dlink position here ! */
+    return sio;
+}
+
+storeIOState *
+storeHashCreate(SwapDir * SD, StoreEntry * e, STFNCB * file_callback, STIOCB * callback, void *callback_data)
+{
+    storeIOState *sio;
+    int fd;
+    int mode = (O_WRONLY | O_CREAT | O_TRUNC);
+    char *path;
+    hashinfo_t *hashinfo = (hashinfo_t *) SD->fsdata;
+    sfileno filn;
+    sdirno dirn;
+
+    /* Allocate a number */
+    dirn = SD->index;
+    filn = storeHashDirMapBitAllocate(SD);
+    hashinfo->suggest = filn + 1;
+    /* Shouldn't we handle a 'bitmap full' error here? */
+#if 0
+    path = storeHashDirFullPath(SD, filn, NULL);
+#endif
+
+    debug(79, 3) ("storeHashCreate: fileno %08X\n", filn);
+    fd = file_open(path, mode);
+    if (fd < 0) {
+	debug(79, 3) ("storeHashCreate: got failure (%d)\n", errno);
+	return NULL;
+    }
+    debug(79, 3) ("storeHashCreate: opened FD %d\n", fd);
+    CBDATA_INIT_TYPE_FREECB(storeIOState, storeHashIOFreeEntry);
+    sio = cbdataAlloc(storeIOState);
+    sio->fsstate = memPoolAlloc(hash_state_pool);
+
+    sio->swap_filen = filn;
+    sio->swap_dirn = dirn;
+    sio->mode = mode;
+    sio->callback = callback;
+    sio->callback_data = callback_data;
+    cbdataLock(callback_data);
+    sio->e = (StoreEntry *) e;
+    ((hashstate_t *) (sio->fsstate))->fd = fd;
+    ((hashstate_t *) (sio->fsstate))->flags.writing = 0;
+    ((hashstate_t *) (sio->fsstate))->flags.reading = 0;
+    ((hashstate_t *) (sio->fsstate))->flags.close_request = 0;
+    store_open_disk_fd++;
+
+    /* now insert into the replacement policy */
+    storeHashDirReplAdd(SD, e);
+    return sio;
+}
+
+void
+storeHashClose(SwapDir * SD, storeIOState * sio)
+{
+    hashstate_t *hashstate = (hashstate_t *) sio->fsstate;
+
+    debug(79, 3) ("storeHashClose: dirno %d, fileno %08X, FD %d\n",
+	sio->swap_dirn, sio->swap_filen, hashstate->fd);
+    if (hashstate->flags.reading || hashstate->flags.writing) {
+	hashstate->flags.close_request = 1;
+	return;
+    }
+    storeHashIOCallback(sio, 0);
+}
+
+void
+storeHashRead(SwapDir * SD, storeIOState * sio, char *buf, size_t size, off_t offset, STRCB * callback, void *callback_data)
+{
+    hashstate_t *hashstate = (hashstate_t *) sio->fsstate;
+
+    assert(sio->read.callback == NULL);
+    assert(sio->read.callback_data == NULL);
+    sio->read.callback = callback;
+    sio->read.callback_data = callback_data;
+    cbdataLock(callback_data);
+    debug(79, 3) ("storeHashRead: dirno %d, fileno %08X, FD %d\n",
+	sio->swap_dirn, sio->swap_filen, hashstate->fd);
+    sio->offset = offset;
+    hashstate->flags.reading = 1;
+    file_read(hashstate->fd,
+	buf,
+	size,
+	offset,
+	storeHashReadDone,
+	sio);
+}
+
+void
+storeHashWrite(SwapDir * SD, storeIOState * sio, char *buf, size_t size, off_t offset, FREE * free_func)
+{
+    hashstate_t *hashstate = (hashstate_t *) sio->fsstate;
+    debug(79, 3) ("storeHashWrite: dirn %d, fileno %08X, FD %d\n", sio->swap_dirn, sio->swap_filen, hashstate->fd);
+    hashstate->flags.writing = 1;
+    file_write(hashstate->fd,
+	offset,
+	buf,
+	size,
+	storeHashWriteDone,
+	sio,
+	free_func);
+}
+
+void
+storeHashUnlink(SwapDir * SD, StoreEntry * e)
+{
+    debug(79, 3) ("storeHashUnlink: fileno %08X\n", e->swap_filen);
+    storeHashDirReplRemove(e);
+    storeHashDirMapBitReset(SD, e->swap_filen);
+    storeHashDirUnlinkFile(SD, e->swap_filen);
+}
+
+/*  === STATIC =========================================================== */
+
+static void
+storeHashReadDone(int fd, const char *buf, int len, int errflag, void *my_data)
+{
+    storeIOState *sio = my_data;
+    hashstate_t *hashstate = (hashstate_t *) sio->fsstate;
+    STRCB *callback = sio->read.callback;
+    void *their_data = sio->read.callback_data;
+    ssize_t rlen;
+
+    debug(79, 3) ("storeHashReadDone: dirno %d, fileno %08X, FD %d, len %d\n",
+	sio->swap_dirn, sio->swap_filen, fd, len);
+    hashstate->flags.reading = 0;
+    if (errflag) {
+	debug(79, 3) ("storeHashReadDone: got failure (%d)\n", errflag);
+	rlen = -1;
+    } else {
+	rlen = (ssize_t) len;
+	sio->offset += len;
+    }
+    assert(callback);
+    assert(their_data);
+    sio->read.callback = NULL;
+    sio->read.callback_data = NULL;
+    if (cbdataValid(their_data))
+	callback(their_data, buf, (size_t) rlen);
+    cbdataUnlock(their_data);
+}
+
+static void
+storeHashWriteDone(int fd, int errflag, size_t len, void *my_data)
+{
+    storeIOState *sio = my_data;
+    hashstate_t *hashstate = (hashstate_t *) sio->fsstate;
+    debug(79, 3) ("storeHashWriteDone: dirno %d, fileno %08X, FD %d, len %d\n",
+	sio->swap_dirn, sio->swap_filen, fd, len);
+    hashstate->flags.writing = 0;
+    if (errflag) {
+	debug(79, 0) ("storeHashWriteDone: got failure (%d)\n", errflag);
+	storeHashIOCallback(sio, errflag);
+	return;
+    }
+    sio->offset += len;
+    if (hashstate->flags.close_request)
+	storeHashIOCallback(sio, errflag);
+}
+
+static void
+storeHashIOCallback(storeIOState * sio, int errflag)
+{
+    hashstate_t *hashstate = (hashstate_t *) sio->fsstate;
+    debug(79, 3) ("storeHashIOCallback: errflag=%d\n", errflag);
+    if (hashstate->fd > -1) {
+	file_close(hashstate->fd);
+	store_open_disk_fd--;
+    }
+    if (cbdataValid(sio->callback_data))
+	sio->callback(sio->callback_data, errflag, sio);
+    cbdataUnlock(sio->callback_data);
+    sio->callback_data = NULL;
+    sio->callback = NULL;
+    cbdataFree(sio);
+}
+
+
+/*
+ * We can't pass memFree() as a free function here, because we need to free
+ * the fsstate variable ..
+ */
+static void
+storeHashIOFreeEntry(void *sio)
+{
+    memPoolFree(hash_state_pool, ((storeIOState *) sio)->fsstate);
+    memFree(sio, MEM_STORE_IO);
+}
squid-modio-HEAD.new squid-modio-HEAD differ: char 65, line 2
